
var visibilityControls = [];
var visibilityValues = [];
var visibilityTypes = [];
var visibilityBackup = [];
var visibilityMenus = [];
var visibilityCount = 0;

document.onclick = function(e) {
    hideAllVisibilityMenus();
	return true;
}

function isVisibilityControlMode()
{
	return hasClass(document.body, 'visibilityControlMode');
}

function setVisibilityValue(name, value)
{
	removeClass(visibilityControls[name], visibilityValues[name] + 'Visibility');
	visibilityValues[name] = value;
	addClass(visibilityControls[name], visibilityValues[name] + 'Visibility');
	var options = visibilityMenus[name].getElementsByTagName('li');
	for (var i = 0; i < options.length; i++) {
		if (hasClass(options[i], value + 'VisibilityOption')) {
			document.getElementById('vhead-' + name).innerHTML = options[i].innerHTML;
			break;
		}
	}
}

function addVisibilityControl(name, visibility, controlType)
{
	var control = document.getElementById('vid-' + name);
	var menu = document.getElementById('vmenu-' + name);
	if (!menu)
		menu = control;

	if (!hasClass(control, 'customizableControl')) {
		var current = control.parentNode;
		while (current != document) {
			if (hasClass(current, 'toolsArea'))
				break;
			current = current.parentNode;
		}
		if (current == document)
			return;
	}

	visibilityControls[name] = control;
	visibilityMenus[name] = menu;
	visibilityValues[name] = visibility;
	visibilityTypes[name] = controlType;
	visibilityCount++;

	menu.onclick = function (e) {
		if (hasClass(this, 'controlVisibilityActive'))
			return false;
		hideAllVisibilityMenus();
        if (!e) var e = window.event;
        e.cancelBubble = true;
        if (e.stopPropagation) e.stopPropagation();
		if (isVisibilityControlMode())
			addClass(this, 'controlVisibilityActive');
        return false;
	};

	var options = menu.getElementsByTagName('li');
	for (var i = 0; i < options.length; i++) {
        options[i].onclick = function (e) {
			if (!name)
				var name = this.parentNode.id.replace(/^vlist-/, '');
			if (!e) var e = window.event;
			e.cancelBubble = true;
			if (e.stopPropagation) e.stopPropagation();
			removeClass(this, 'activeVisibilityOption');
			removeClass(visibilityMenus[name], 'controlVisibilityActive');
			setVisibilityValue(name, this.className.replace(/VisibilityOption/,''));
			return false;
        };
	}
}

function collectVisibilityValues(form)
{
	for (var i in visibilityValues) {
		var page;
		var control;
		var item;
		var parts = i.split(':', 2);
		if (parts.length == 2) {
			page = parts[0];
			control = parts[1];
		} else {
			page = visibilityPage;
			control = i;
		}
		item = form.ownerDocument.createElement("input");
		item.setAttribute("type", "hidden");
		item.setAttribute("name", "customizations[" + page + "][" + control + "][visibility]");
		item.setAttribute("value", visibilityValues[i]);
		form.insertBefore(item, null);
		item = form.ownerDocument.createElement("input");
		item.setAttribute("type", "hidden");
		item.setAttribute("name", "customizations[" + page + "][" + control + "][controlType]");
		item.setAttribute("value", visibilityTypes[i]);
		form.insertBefore(item, null);
	}
}

function hideAllVisibilityMenus() {
	if (visibilityMenus) {
		for (var i in visibilityMenus)
			removeClass(visibilityMenus[i], 'controlVisibilityActive');
	}
}
